//
// MySQL_db.cc
//
// SQL implementation, written by Zoran Constantinescu <zoran@idi.ntnu.no>
//
#if RELEASE
static char RCSid[] = "$Id: MySQL_db.cc $";
#endif

#include <stream.h>

#include "MySQL_db.h"
#include <mysql.h>

int   MySQL_db::isConnect = 0;
MYSQL MySQL_db::mysql;

MySQL_db::MySQL_db ()
{
}


MySQL_db::~MySQL_db ()
{
}


void
MySQL_db::Lock (String &sTable)
{
  String s_lock;
  int err;

  s_lock << "lock tables " << sTable;

  if (! (err = mysql_query (&mysql, s_lock)))
  {
    String s;
    s << "Lock(" << sTable << ") -- OK\n";
    LogLine (s, 2);
  } 
  else
  {
    String s;
    s << "Lock(" << sTable << ") -- failed -- "
      << "error: '" << mysql_error (&mysql) << "'.\n";
    LogError (s);
  } 
}


void
MySQL_db::UnLock ()
{
  String s_unlock;
  int err;

  s_unlock << "unlock tables";

  if (! (err = mysql_query (&mysql, s_unlock)))
  {
    String s;
    s << "UnLock() -- OK\n";
    LogLine (s, 2);
  } 
  else
  {
    String s;
    s << "UnLock() -- failed -- "
      << "error: '" << mysql_error (&mysql) << "'.\n";
    LogError (s);
  } 
}


/*****************************************************************/
/*  Create a connection with the SQL server                      */
/*****************************************************************/
int
MySQL_db::Connect (char *host, char *db, char *user, char *pswd)
{
  timeb t0;
  ftime (&t0);

  if (isConnect)
    return OK;

  if (! mysql_connect (&mysql, host, user, pswd))
  {
    String s;
    s << "Connect() -- failed -- "
      << "server='" << host << "' "
      << "user='" << user << "'; "
      << "error: '" << mysql_error (&mysql) << "'.\n";
    LogError (s);
    exit (1);
    return LogTime (NOTOK, "Connect", t0);
  }

  if (mysql_select_db (&mysql, db))
  {
    String s;
    s << "Select() -- failed -- "
      << "database='" << db << "'; "
      << "error: '" << mysql_error(&mysql) << "'.\n";
    LogError (s);
    exit (1);
    return LogTime (NOTOK, "Connect", t0);
  }

  String s;
  s << "Connect("
    << "server='" << host << "' "
    << "user='" << user << "' "
    << "database='" << db << "')\n";
  LogLine (s, 1);

  LogTime (OK, "Connect", t0);

  isConnect = 1;
  return OK;
}


/*****************************************************************/
/*  Close the connection with the SQL server                     */
/*****************************************************************/
int
MySQL_db::Disconnect ()
{
//zrn Find a way to disconnect only once!
  return OK;

  timeb t0;
  ftime (&t0);

  mysql_close (&mysql);

  String s;
  s << "Disconnect()\n";
  LogLine (s, 1);

  LogTime (OK, "Disconnect", t0);

  return OK;
}

	
int
MySQL_db::ExecQuery (String &sSelect)
{
  int err;
  timeb t0;
  ftime (&t0);

//  cerr << sSelect << endl;

  if (err = mysql_query (&mysql, sSelect)) 
  {
    String s;
    s << "ExecQuery('" << sSelect  << "') -- failed -- "
      << "error: '" << mysql_error (&mysql) << "'.\n";
    LogError (s);

    err = NOTOK;
  }

  LogTime (err, "GetNewURL", t0);

  return err;
}


/*****************************************************************/
/*  Create an instance of the database                           */
/*****************************************************************/
MySQL_db *
MySQL_db::getDatabaseInstance()
{
  return new MySQL_db();
}


void
MySQL_db::QuoteString (String &s)
{
  String ss;

  for (int i = 0; i < s.length (); i++)
    if (s[i] == '\'')
      ss << "\\'";
    else
      ss << s[i];

  s = ss;
}


int
MySQL_db::GetInsertID ()
{
  return mysql_insert_id (&mysql);
}


int
MySQL_db::StoreResult ()
{
  result = mysql_store_result (&mysql);

  return 0;
}


void
MySQL_db::FreeResult (int nResult)
{
  mysql_free_result (result);
}


int
MySQL_db::NumRows (int nResult)
{
  return mysql_num_rows (result);
}


char **
MySQL_db::FetchRow (int nResult)
{
  return mysql_fetch_row (result);
}


char *
MySQL_db::Error ()
{
  return mysql_error (&mysql);
}

